/**
 * [a2, b2, a3, b3] = _mm_unpackhi_ps([a0, a1, a2, a3], [b0, b1, b2, b3]);
 */

#include <xmmintrin.h>


#include <iostream>

using namespace std;


void display(float* v) {
  cout << v[0] << '\t' << v[1] << '\t' << v[2] << '\t' << v[3] << endl;
}


int main() {

  float a0[4] __attribute__((aligned(16))) = {1, 2, 3.5, 4};
  float a1[4] __attribute__((aligned(16))) = {5, 6, 7, 8};
  float a2[4] __attribute__((aligned(16)));

  __m128 r0, r1;

  display(a0);
  display(a1);

  r0 = _mm_load_ps(a0);
  r1 = _mm_load_ps(a1);

  r0 = _mm_unpackhi_ps(r0, r1);

  _mm_store_ps(a2, r0);

  display(a2);

}
