#include <xmmintrin.h>

#include <iostream>
using namespace std;

int main() {

  // alloc. statique alignée
  float a1[4] __attribute__((aligned(16))) = {1.f, 2.f, 3.f, 4.f};
  // alloc. dynamique alignée
  float* a2 = (float*)_mm_malloc(4*sizeof(float), 16);

  float a3[4] __attribute__((aligned(16)));

  __m128 r1, r2;

  for(unsigned int i = 0 ; i < 4 ; ++i) {

    a2[i] = i;

  }

  r1 = _mm_load_ps(a1);
  r2 = _mm_load_ps(a2);

  r1 = _mm_add_ps(r1, r2);

  _mm_store_ps(a3, r1);

  for(unsigned int i = 0 ; i < 4 ; ++i) {

    cout << a3[i] << endl;

  }

  _mm_free(a2);

  return 0;

}
