/**
 * int(a0) = _mm_cvtss_si32([a0, a1, a2, a3]);
 */

#include <xmmintrin.h>


#include <iostream>

using namespace std;


void display(float* v) {
  cout << v[0] << '\t' << v[1] << '\t' << v[2] << '\t' << v[3] << endl;
}


int main() {

  float a0[4] __attribute__((aligned(16))) = {1.2, 2.3, 3.7, 4.9};
  int res;

  __m128 r0;

  display(a0);

  r0 = _mm_load_ps(a0);

  res = _mm_cvtss_si32(r0);

  cout << res << endl;

}
