/**
 * [int(a0), int(a1), int(a2), int(a3)] = _mm_cvtps_epi32([a0, a1, a2, a3]);
 */

#include <emmintrin.h>


#include <iostream>

using namespace std;


void display(float* v) {
  cout << v[0] << '\t' << v[1] << '\t' << v[2] << '\t' << v[3] << endl;
}
void display(int* v) {
  cout << v[0] << '\t' << v[1] << '\t' << v[2] << '\t' << v[3] << endl;
}


int main() {

  float a0[4] __attribute__((aligned(16))) = {1.1, 2.1, 3.6, 4.8};
  int a1[4] __attribute__((aligned(16)));

  __m128 r0;
  __m128i r1;

  display(a0);

  r0 = _mm_load_ps(a0);

  r1 = _mm_cvtps_epi32(r0);

  _mm_store_si128((__m128i*)a1, r1);

  display(a1);

}
