/**
 * dotproduct = _mm_dp_ps([a0, a1, a2, a3], [b0, b1, b2, b3], mask);
 */

#include <smmintrin.h>


#include <iostream>

using namespace std;


void display(float* v) {

  for(unsigned int i = 0 ; i < 4 ; ++i) {
    cout << (int)(v[i]) << '\t';
  }
  cout << endl;

}


int main() {

  float a0[4] __attribute__((aligned(16))) = {0, 1, 2, 3};
  float a1[4] __attribute__((aligned(16))) = {3, 2, 1, 0};
  float a2[4] __attribute__((aligned(16)));

  __m128 r0, r1, r2;

  display(a0);
  display(a1);

  r0 = _mm_load_ps(a0);
  r1 = _mm_load_ps(a1);

  r2 = _mm_dp_ps(r0, r1, 0xff);

  _mm_store_ps(a2, r2);

  display(a2);

}
